var montharray = ["January","February","March","April","May","June","July","August","September","October","November","December"];

function PopulatePopup() {
	var monthspop = document.getElementById("monthspopup");
	for (i=0; i < montharray.length; i++) {
		monthspop.appendChild(document.createElement("menuitem"));
		monthspop.lastChild.setAttribute("label", montharray[i]);
		monthspop.lastChild.setAttribute("value", i);
		monthspop.lastChild.setAttribute("oncommand", "MonthChange(this.value);");
	}
}

function UpdateCalendar(Calendar) {
	// This function draws the calendar.
	var year = Calendar.getFullYear();
	var month = Calendar.getMonth();
	var today = Calendar.getDate();
	var weekday = Calendar.getDay();
	var todaycal = new Date();
	Calendar.setDate(1);
	Calendar.setMonth(month);
	
	// Theres a few duplicate variables in here, I can't be arsed going back over all this to remove them though. It works, so I'm not
	// touching it again unless I have to.
	curmonth = month;

	// Set the top labels of month and year.
	document.getElementById("monthlabel").value = montharray[month];
	document.getElementById("yearlabel").value = year;
	var index = Calendar.getDay();

	var cbox = document.getElementById("calendarboxrows");

	// If there's anything else on the calendar, wipe it out.
	while (cbox.childNodes.length > 1) {
		cbox.removeChild(cbox.lastChild);
	}

	// Start the first row.
	cbox.appendChild(document.createElement("row"));

	// This pads out the start of the calendar until the first day of the month. For example, if the first day is a Friday, then all the boxes
	// from Sunday to Thursday have to be blank in the first row.
	for (i = 0; i < index; i++) {
		cbox.childNodes[1].appendChild(document.createElement("spacer"));
	}

	// This draws up the dates. It runs 31 times through, because you're not going to have any months longer than that.
	for (i = 0; i < 31; i++) {
		if (Calendar.getDate() > i) {
			// While there's still dates remaining in the month...
			week_day = Calendar.getDay();
			if (week_day == 0) {
				// This finds what number the day of the week is. If it's a 0, then its Sunday, so a new row should be started.
				cbox.appendChild(document.createElement("row"));
			}
			if (week_day != 7) {
				var day = Calendar.getDate();
				// Add another button to the row, and set it up to show a number and have some stuff attached.
				cbox.lastChild.appendChild(document.createElement("toolbarbutton"));
				cbox.lastChild.childNodes[week_day].setAttribute("label", Calendar.getDate());
				cbox.lastChild.childNodes[week_day].setAttribute("oncommand", "SetSelected(this);");
				cbox.lastChild.childNodes[week_day].setAttribute("id", "day" + Calendar.getDate());
				if ((today == day) && (todaycal.getMonth() == month)) {
					// This originally would SetSelected() the day that was today, but it kept buggering up so now it sets this and SetSelected gets called after this
					// function finishes.
					selectedday = today;
				}
			}
		}
		Calendar.setDate(Calendar.getDate() +1);
	}
	// Dug this out of the guts of MailNews... This is how you locally format a short date for the user's locale, because JS doesn't actually do it itself...
	var dateformatter = Components.classes["@mozilla.org/intl/scriptabledateformat;1"].getService(Components.interfaces.nsIScriptableDateFormat);
	document.getElementById("datelabel").value = "Today: " + dateformatter.FormatDate("", dateformatter.dateFormatShort, todaycal.getFullYear(), todaycal.getMonth()+1, todaycal.getDate());
}

function SetSelected(thing) {
	// This function puts a pretty little box around the last button that was clicked, and sends off the request to update the entries list.
	var cbox = document.getElementById("calendarboxrows");
	for (i = 1; i < cbox.childNodes.length; i++) {
		for (j = 0; j < cbox.childNodes[i].childNodes.length; j++) {
			cbox.childNodes[i].childNodes[j].removeAttribute("class");
		}
	}
	if (!thing) { thing = document.getElementById("day" + selectedday); }
	thing.setAttribute("class", "SelectedBox");
	selectedday = thing.label;
	if (window.name == "dsHistory") {
		var body;
		body = "mode=getevents&user=" + escape(opener.username) + "&hpassword=" + escape(opener.hexMD5(opener.password)) + "&ver=1";
		body += "&truncate=40&prefersubject=1&noprops=1&selecttype=day&lineendings=space"
		body += "&year=" + document.getElementById("yearlabel").value;
		body += "&month=" + (curmonth + 1);
		body += "&day=" + selectedday;
		if (username != usejournal) {
			body += "&usejournal=" + escape(usejournal);
		}
		var eventlist = document.getElementById("entrieslist");
		while (eventlist.childNodes.length > 2) {
			eventlist.removeChild(eventlist.lastChild);
		}
		eventlist.appendChild(document.createElement("listitem"));
		eventlist.lastChild.setAttribute("label", "Loading...");
		SendRequest("POST", LJURL, body, ShowEntries, CantLoadEntries);
	}
}

function DoBoldDays() {
	// This is to set any day that has an entry greater or equal to 1, as bold.
	var year = document.getElementById("yearlabel").value;
	var month = curmonth + 1;
	for (i = 0; i < 31; i++) {
		var day = i + 1;
		if (getResponseData(year + "-" + ZeroFix(month) + "-" + ZeroFix(day), calendarresponse) > 0) {
			document.getElementById("day" + day).setAttribute("style", "font-weight: bold");
		}
	}
}

function PlusMinusDate(monthdiff) {
	var cal = new Date();
	cal.setFullYear(document.getElementById("yearlabel").value);
	var newmonth = curmonth + monthdiff;
	cal.setFullYear(cal.getFullYear(),newmonth);
	UpdateCalendar(cal);
	if (window.name == "dsHistory") {
		DoBoldDays();
	}
}

function MonthChange(tomonth) {
	var cal = new Date();
	cal.setFullYear(document.getElementById("yearlabel").value,tomonth);
	UpdateCalendar(cal);
	if (window.name == "dsHistory") {
		DoBoldDays();
	}
}